﻿

#include "hmg.ch"

Function Main

   SET CODEPAGE TO UNICODE

   public aRows [21] [3]

   aRows [1]    := {'Simpson','Homer','555-5555'}
   aRows [2]    := {'Mulder','Fox','324-6432'} 
   aRows [3]    := {'Smart','Max','432-5892'} 
   aRows [4]    := {'Grillo','Pepe','894-2332'} 
   aRows [5]    := {'Kirk','James','346-9873'} 
   aRows [6]    := {'Barriga','Carlos','394-9654'} 
   aRows [7]    := {'Flanders','Ned','435-3211'} 
   aRows [8]    := {'Smith','John','123-1234'} 
   aRows [9]    := {'Pedemonti','Flavio','000-0000'} 
   aRows [10]   := {'Gomez','Juan','583-4832'} 
   aRows [11]   := {'Fernandez','Raul','321-4332'} 
   aRows [12]   := {'Borges','Javier','326-9430'} 
   aRows [13]   := {'Alvarez','Alberto','543-7898'} 
   aRows [14]   := {'Gonzalez','Ambo','437-8473'} 
   aRows [15]   := {'Batistuta','Gol','485-2843'} 
   aRows [16]   := {'Vinazzi','Amigo','394-5983'} 
   aRows [17]   := {'Pedemonti','Flavio','534-7984'} 
   aRows [18]   := {'Samarbide','Armando','854-7873'} 
   aRows [19]   := {'Pradon','Alejandra','???-????'} 
   aRows [20]   := {'Reyes','Monica','432-5836'} 
   aRows [21]   := {'Fernández','two','0000-0000'} 


   DEFINE WINDOW Form_1 ;
      AT 0,0 ;
      WIDTH 800 ;
      HEIGHT 650 ;
      TITLE "Incremental search in grid" ;
      MAIN 

      @  10, 10 Label L1 ;
         width 80;
         height 18;
         value "Search string:"

      @  30, 10 TEXTBOX T_WhatToSearch ;
         width 600;
         height 24;
         value "" ;
		 On Change Proc_GridSearchString()
      
      @ 80,10 GRID Grid_1 ;
         WIDTH 760 ;
         HEIGHT 500 ;
         HEADERS {'Last Name','First Name','Phone'} ;
         WIDTHS {140,140,140};
         ITEMS aRows ;
         VALUE 1;
         EDIT;
         JUSTIFY { GRID_JTFY_LEFT,GRID_JTFY_LEFT, GRID_JTFY_RIGHT }

   END WINDOW

   CENTER WINDOW Form_1
	
	// this event allows to use arrow heys to scroll grid when T_WhatToSearch is focused
	// works OK with HMG 3.1.5 
   // this event blocks T_WhatToSearch textbox
	CREATE EVENT PROCNAME KeyUpDown_Action('Form_1', 'T_WhatToSearch','Grid_1') HWND Form_1.T_WhatToSearch.HANDLE MSG WM_KEYDOWN
   
   ACTIVATE WINDOW Form_1

Return
*---------------------
PROCEDURE KeyUpDown_Action(cForm, cCurrentControl, cGridName)

	STATIC flag := .F.
	LOCAL hWnd, ch
	local lFound := .f.
	local nPos := len(GetProperty(cForm, cCurrentControl,"Value"))
	local nRet := 0
	
	// Value nRet := 1 is required to avoid process arrow key by textbox T_WhatToSearch
	
	if flag == .t.
		return NIL  // avoid re-entry
	endif

	flag := .T.
	ch := HMG_GetLastCharacter(@hWnd)
	IF hWnd == GetControlHandle (cCurrentControl,cForm)
		if HMG_GetLastVirtualKeyDown() == VK_UP
			IF GetProperty( cForm, cGridName, "ItemCount" ) > 0 .AND. ;
						GetProperty( cForm, cGridName, "VALUE" ) > 1
				SetProperty( cForm, cGridName, "VALUE", GetProperty( cForm, cGridName, "VALUE" ) - 1 )
				
			endif
			nRet := 1
		endif
		if HMG_GetLastVirtualKeyDown() == VK_DOWN
			IF GetProperty( cForm, cGridName, "ItemCount" ) > 0 .AND. ;
						GetProperty( cForm, cGridName, "VALUE" ) < GetProperty( cForm, cGridName, "ItemCount" )
				SetProperty( cForm, cGridName, "VALUE", GetProperty( cForm, cGridName, "VALUE" ) + 1 ) 
			endif
			nRet := 1
		endif
	endif
	flag := .F.
	

RETURN nRet// KeyUpDown_Action()
*---------------------


****************************************************************
 Function Proc_GridSearchString   // New version (April 2014)
****************************************************************
   STATIC nRow := 0
   local ch, i, k, cLocalSearchString 
 
	cLocalSearchString := Form_1.T_WhatToSearch.Value

	i := 0
   FOR k = 1 TO Form_1.Grid_1.ItemCOUNT
      #define COL_SEARCH   1
      IF HMG_UPPER(HB_ULEFT(Form_1.Grid_1.CellEx(k,COL_SEARCH), HMG_LEN(cLocalSearchString))) == HMG_UPPER(cLocalSearchString)
         i := k
         nRow := k   // remember last found string
         EXIT
      ENDIF
   NEXT

   if i > 0
      Form_1.Grid_1.Value := i                    // found - move pointer of grid
   else
      Form_1.Grid_1.Value := nRow                 // not found - move pointer of the last found string
	  Form_1.T_WhatToSearch.Value := HB_ULeft(cLocalSearchString, max(HB_ULen(cLocalSearchString)-1, 1))
   endif

return 1   // prevents the processing of the current message
